import dotenv from 'dotenv';
import { FisAppActor, FisMessage, TransmissionMessage } from "../interface/transport.interface";
import { ConnectionAdapter } from "./connector.base";
import { RequestResponseConnectionAdapter as RequestResponseConnectionAdapterInterface, TransportEvent, TransportMessage } from "../interface/connector.interface";
import { TransmitterConnectionAdapter } from './connector.transmitter';
import { ReceiverConnectionAdapter } from './connector.receiver';
import { Observable, Observer, Subject } from 'rxjs';

dotenv.config();
/* This transport manager will be instantiating the necessary transport to deal with tranmission and receiving from different receivers
So how?: */
export class RequestResponseConnectionAdapter extends ConnectionAdapter implements RequestResponseConnectionAdapterInterface {
    event: Subject<TransportEvent> = new Subject()
    incomingResponses: Subject<TransportMessage> = new Subject()

    constructor(transmitterAdapter: TransmitterConnectionAdapter, receiverAdapter: ReceiverConnectionAdapter) {
        super()
        // logic here
    }
    
    emit(message: TransmissionMessage): void {
        throw new Error('Method not implemented.');
    }
    emitStream(message: TransmissionMessage): void {
        throw new Error('Method not implemented.');
    }

    send(message: TransmissionMessage): Observable<TransportMessage> {
        return new Observable((response: Observer<TransportMessage>) => {
            // logic here
        })
    }
}


